local Zifnabs_Config_Listener = {}
_G.Zifnabs_Config_Listener = Zifnabs_Config_Listener

local config_frame=getglobal("Zifnabs_Configuration")
local my_name="Zifnabs_Configuration_Listener"
local my_frame=getglobal(my_name)
local unsaved_changes=false
local editmode=false
local selector={}
local selected={}
local channels={"WHISPER","SAY","PARTY","GUILD","ZONE","YELL","SYSTEM"}


Zifnabs_Config:register_module(Zifnabs.LANG.Config_LISTENER_SELECT,Zifnabs_Config_Listener)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_Config_Listener:changes(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local min=tonumber(getglobal(my_name.."_Delay_Min_Value_Text"):GetText())
	local max=tonumber(getglobal(my_name.."_Delay_Max_Value_Text"):GetText())
	if id=="min_minus" then 
		min=math.max(0,min-0.1)
	elseif id=="min_plus" then 
		min=math.min(99,min+0.1)
		max=math.max(min,max)
	elseif id=="max_minus" then 
		max=math.max(0,max-0.1)
		min=math.min(min,max)
	elseif id=="max_plus" then 
		max=math.min(99,max+0.1)
	end
	getglobal(my_name.."_Delay_Min_Value_Text"):SetText(min)
	getglobal(my_name.."_Delay_Max_Value_Text"):SetText(max)
	if editmode then unsaved_changes=true end
end

function Zifnabs_Config_Listener:radio(widget)
	for c=1,#channels,1 do getglobal(my_name.."_Channel_"..channels[c]):SetChecked(false) end
	widget:SetChecked(true)
	if editmode then unsaved_changes=true end
end

function Zifnabs_Config_Listener:check(widget)
	if editmode then unsaved_changes=true end
end

function Zifnabs_Config_Listener_init_Select()
	local init_selection=selected
	selector={}
	if selected.channel==nil or selected.caption==nil then init_selection.id=1 end
	local menuitem={checked=nil,func=Zifnabs_Config_Listener_select_func,text=""}
	for channel,searches in pairs(Zifnabs_Settings.listen) do
		for caption,entry in pairs(searches) do
			menuitem.text=caption
			selector[1+#selector]={["caption"]=menuitem.text,["channel"]=channel}
			if channel==init_selection.channel and caption==init_selection.caption then init_selection.id=#selector end
			UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL)
		end
	end
	menuitem.text=Zifnabs.LANG.Config_LISTENER_NEW
	selector[1+#selector]={["caption"]="",["channel"]=nil}
	UIDropDownMenu_AddButton(menuitem,UIDROPDOWNMENU_MENU_LEVEL)
	Zifnabs_Config_Listener_select_func(init_selection.id)
end

function Zifnabs_Config_Listener_select_func(widget)
	if widget~=nil then 
		if editmode and unsaved_changes then Zifnabs_Config_Listener:save() end
		local id=widget
		if type(id)~="number" then id=tonumber(widget:GetID()) end
		selected=selector[id]
		local item={search={},active=false,alarm=nil,delay=nil,say={}}
		if selected.channel~=nil then 
			Zifnabs_Config_Listener:radio(getglobal(my_name.."_Channel_"..selected.channel))
			item=Zifnabs_Settings.listen[selected.channel][selected.caption] 
		end
		getglobal(my_name.."_Caption"):SetText(selected.caption)
		getglobal(my_name.."_Active"):SetChecked(item.active)
		for i=1,6,1 do
			getglobal(my_name.."_SearchFor_"..i):SetText(item.search[i] or "")
		end
		getglobal(my_name.."_Alarm"):SetChecked(item.alarm~=nil)
		getglobal(my_name.."_Delay"):SetChecked(item.delay~=nil)
		if item.delay==nil then
			getglobal(my_name.."_Delay_Min_Value_Text"):SetText("0")
			getglobal(my_name.."_Delay_Max_Value_Text"):SetText("0")
		else
			getglobal(my_name.."_Delay_Min_Value_Text"):SetText(item.delay[1]/1000)
			getglobal(my_name.."_Delay_Max_Value_Text"):SetText(item.delay[2]/1000)
		end
		for s=1,8,1 do
			local text=""
			if item.say~=nil then text=item.say[s] or "" end
			getglobal(my_name.."_Reaction_"..s):SetText(text)
		end
		UIDropDownMenu_SetText(getglobal(my_name.."_Select"), selected.caption);
	end
end;

-- ******************************************************************************************
-- * API Funktionen für Zifnabs_Config
-- ******************************************************************************************
function Zifnabs_Config_Listener:enter()
	editmode=false
	my_frame:Show()
	getglobal(my_name.."_Caption_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_CAPTION)
	getglobal(my_name.."_Save"):SetText(Zifnabs.LANG.Config_SIA_SAVE)
	getglobal(my_name.."_Delete"):SetText(Zifnabs.LANG.Config_LISTENER_DELETE)
	getglobal(my_name.."_Active_Text"):SetText(Zifnabs.LANG.Config_LISTENER_ACTIVE)
	getglobal(my_name.."_Channel_WHISPER_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_WHISPER)
	getglobal(my_name.."_Channel_SAY_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_SAY)
	getglobal(my_name.."_Channel_PARTY_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_PARTY)
	getglobal(my_name.."_Channel_GUILD_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_GUILD)
	getglobal(my_name.."_Channel_ZONE_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_ZONE)
	getglobal(my_name.."_Channel_YELL_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_YELL)
	getglobal(my_name.."_Channel_SYSTEM_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_SYSTEM)
	getglobal(my_name.."_SearchFor_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_SEARCHFOR)
	getglobal(my_name.."_Alarm_Text"):SetText(Zifnabs.LANG.Config_LISTENER_ALARM)
	getglobal(my_name.."_Delay_Text"):SetText(Zifnabs.LANG.Config_LISTENER_DELAY)
	getglobal(my_name.."_Delay_To_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_DELAY_TO)
	getglobal(my_name.."_Reaction_Label_Text"):SetText(Zifnabs.LANG.Config_LISTENER_REACTION)
	UIDropDownMenu_Initialize(getglobal(my_name.."_Select"), Zifnabs_Config_Listener_init_Select);
	editmode=true
end

function Zifnabs_Config_Listener:leave()
	if unsaved_changes then Zifnabs_Config:save_ignore_abort("ASK")  
	else 
		my_frame:Hide()
		Zifnabs_Config:left_menu()
	end
end

function Zifnabs_Config_Listener:delete()
	if Zifnabs_Settings.listen[selected.channel]~=nil then 
		Zifnabs_Settings.listen[selected.channel][selected.caption]=nil
		selected={}
		Zifnabs_Listener:reload_settings()
		Zifnabs_Config_Listener:enter()	
	end
end
function Zifnabs_Config_Listener:save()
	if unsaved_changes then
		local savechannel=""
		for c=1,#channels,1 do 
			if getglobal(my_name.."_Channel_"..channels[c]):IsChecked() then savechannel=channels[c] end
		end
		caption=getglobal(my_name.."_Caption"):GetText()

		if Zifnabs_Settings.listen[selected.channel]~=nil then Zifnabs_Settings.listen[selected.channel][selected.caption]=nil end

		local entry={}
		entry.active=getglobal(my_name.."_Active"):IsChecked()
		if getglobal(my_name.."_Alarm"):IsChecked() then entry.alarm="ding.mp3" else entry.alarm=nil end
		entry.search={}
		for s=1,6,1 do
			local text=getglobal(my_name.."_SearchFor_"..s):GetText()
			while string.sub(text,1,1)==" " do text=string.sub(text,2) end
			while string.sub(text,-1,-1)==" " do text=string.sub(text,1,-2) end
			if text~="" then entry.search[1+#entry.search]=string.lower(text) end
		end
		if getglobal(my_name.."_Delay"):IsChecked() then
			local min=1000*tonumber(getglobal(my_name.."_Delay_Min_Value_Text"):GetText())
			local max=1000*tonumber(getglobal(my_name.."_Delay_Max_Value_Text"):GetText())
			entry.delay={min,max}
		end
		entry.say={}
		for s=1,8,1 do
			local text=getglobal(my_name.."_Reaction_"..s):GetText()
			while string.sub(text,1,1)==" " do text=string.sub(text,2) end
			while string.sub(text,-1,-1)==" " do text=string.sub(text,1,-2) end
			if text~="" then entry.say[1+#entry.say]=text end
		end
	
		if Zifnabs_Settings.listen[savechannel]==nil then Zifnabs_Settings.listen[savechannel]={} end
		Zifnabs_Settings.listen[savechannel][caption]=entry
		unsaved_changes=false 
		selected={["channel"]=savechannel,["caption"]=caption}
		Zifnabs_Listener:reload_settings()
		Zifnabs_Config_Listener:enter()
	end
end 
function Zifnabs_Config_Listener:ignore() unsaved_changes=false end
function Zifnabs_Config_Listener:disable() my_frame:Disable() end
function Zifnabs_Config_Listener:enable()	my_frame:Enable() end
