local Zifnabs_RP = {}
_G.Zifnabs_RP = Zifnabs_RP

local default_settings={
	["rp_say"]={
		[1]={["caption"]=Zifnabs.LANG.RP_HI,["notarget"]={Zifnabs.LANG.RP_HI_NOTARGET1,Zifnabs.LANG.RP_HI_NOTARGET2},["any"]={Zifnabs.LANG.RP_HI_ANY1,Zifnabs.LANG.RP_HI_ANY2},["female"]={},["male"]={}},
		[2]={["caption"]=Zifnabs.LANG.RP_BYE,["notarget"]={Zifnabs.LANG.RP_BYE_NOTARGET1,Zifnabs.LANG.RP_BYE_NOTARGET2},["any"]={Zifnabs.LANG.RP_BYE_ANY1,Zifnabs.LANG.RP_BYE_ANY2},["female"]={},["male"]={}},
		[3]={["caption"]=Zifnabs.LANG.RP_THANKS,["notarget"]={Zifnabs.LANG.RP_THANKS_NOTARGET1,Zifnabs.LANG.RP_THANKS_NOTARGET2},["any"]={Zifnabs.LANG.RP_THANKS_ANY1,Zifnabs.LANG.RP_THANKS_ANY2},["female"]={},["male"]={}},
	},
}
for b=1,12,1 do
	if default_settings.rp_say[b]==nil then default_settings.rp_say[b]={["caption"]="",["any"]={}} end
end
local settings={}

local my_name="Zifnabs_RolePlay"
local control=getglobal("Zifnabs_RP_Control")

Zifnabs:plugin("Zifnabs_RP",Zifnabs_RP,false)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_RP:OnEvent(event,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
	if event=="VARIABLES_LOADED" then
		Zifnabs_RP:reload_settings()
		Zifnabs:dofile("Zifnabs_Config_RP")	
	elseif event=="SAVE_VARIABLES" then
		Zifnabs:save_settings(default_settings,settings)
	else Zifnabs:echo("RP: "..event.." "..type(arg1).." "..type(arg2))		
	end
end

function Zifnabs_RP:reload_settings()
	settings=Zifnabs:init_settings(default_settings)
	local highest=0
	for b=1,12,1 do
		local button=getglobal(my_name.."_"..b)
		if settings.rp_say[b]["caption"]=="" then button:Hide()
		else
			button:Show()
			highest=math.ceil(b/3)
			button:SetText(settings.rp_say[b]["caption"])
		end
	end
	getglobal("Zifnabs_RolePlay"):SetHeight(20*highest)
end

function Zifnabs_RP:button(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local bnumber=1*part[#part]

	local table1={}
	local table2={}
	local message=""
	if (UnitExists("target")) then
		table1=settings.rp_say[bnumber]["any"]
		if UnitIsUnit("player","target") then table1=settings.rp_say[bnumber]["notarget"]
		elseif UnitIsPlayer("target") and UnitSex("target")==0 then table2=settings.rp_say[bnumber]["male"]
		elseif UnitIsPlayer("target") and UnitSex("target")==1 then table2=settings.rp_say[bnumber]["female"]
		end
	else
		table1=settings.rp_say[bnumber]["notarget"]
	end
	if table1==nil then table1=settings.rp_say[bnumber]["any"] end
	if table2==nil then table2={} end
	local select=math.random(#table1+#table2)
	if select<=#table1 then	message=table1[select] else message=table2[select-#table1] end
	if message then
		local emote=nil
		if string.sub(message,1,1)=="[" then
			local delim=string.find(message,"]",2,true)
			if delim~=nil then
				emote=string.sub(message,2,delim-1)
				message=string.sub(message,delim+1)
			end
		end
		local channel="SAY"
		local choice=string.lower(string.sub(message,1,2))
		local valid={["/s"]="SAY",["/g"]="GUILD",["/p"]="PARTY",["/z"]="ZONE",["/w"]="WORLD"}
		if valid[choice] then
			channel=valid[choice]
			message=string.sub(message,3)
		end
		SendChatMessage(message, channel, 0);
		if emote~=nil then Zifnabs:runcommand("/"..emote) end -- dies muss letzter Befehl bleiben, weil ungltige emotes Ausfhrung hier abbrechen
	else
		Zifnabs:error(Zifnabs.LANG.RP_NO_MESSAGE)
	end
end
